#from .arithmetic import *
#from .base import *
#from .decorator import *
#from .exception import *
#from .inheritance import *
#from .logical import *
#from .loop import *
#from .misc import *
try:
    import utils
    from operators.arithmetic import *
    from operators.base import *
    from operators.decorator import *
    from operators.exception import *
    from operators.inheritance import *
    from operators.logical import *
    from operators.loop import *
    from operators.misc import *
    from operators.type_dependant import *
except (ImportError,ModuleNotFoundError) as e:
    from mutpy import utils
    from .arithmetic import *
    from .base import *
    from .decorator import *
    from .exception import *
    from .inheritance import *
    from .logical import *
    from .loop import *
    from .misc import *
    from .type_dependant import *


SuperCallingInsert = utils.get_by_python_version([
    SuperCallingInsertPython27,
    SuperCallingInsertPython35,
])

standard_operators = {
    ArithmeticOperatorDeletion,
    ArithmeticOperatorReplacement,
    AssignmentOperatorReplacement,
    BreakContinueReplacement,
    ConditionalOperatorDeletion,
    ConditionalOperatorInsertion,
    ConstantReplacement,
    DecoratorDeletion,
    ExceptionHandlerDeletion,
    ExceptionSwallowing,
    HidingVariableDeletion,
    LogicalConnectorReplacement,
    LogicalOperatorDeletion,
    LogicalOperatorReplacement,
    OverriddenMethodCallingPositionChange,
    OverridingMethodDeletion,
    RelationalOperatorReplacement,
    SliceIndexRemove,
    SuperCallingDeletion,
    SuperCallingInsert,
}

experimental_operators = {
    ClassmethodDecoratorInsertion,
    OneIterationLoop,
    ReverseIterationLoop,
    SelfVariableDeletion,
    StatementDeletion,
    StaticmethodDecoratorInsertion,
    ZeroIterationLoop,
}

type_dependant_operators = {
	ConstantReplacementByAVariable
}
