import ast

try:
    from operators.base import MutationOperator, MutationResign
except (ImportError,ModuleNotFoundError) as e:
    from mutpy.operators.base import MutationOperator, MutationResign

import pdb

class BaseExceptionHandlerOperator(MutationOperator):

    @staticmethod
    def _replace_exception_body(exception_node, body):
        return ast.ExceptHandler(type=exception_node.type, name=exception_node.name, lineno=exception_node.lineno,
                                 body=body)


class ExceptionHandlerDeletion(BaseExceptionHandlerOperator):
    def mutate_ExceptHandler(self, node):
        try:
            if node.body and isinstance(node.body[0], ast.Raise):
                raise MutationResign()
            to_return= self._replace_exception_body(node, [ast.Raise(lineno=node.body[0].lineno)])
        except AttributeError as ae:
            pdb.set_trace()
        return to_return


class ExceptionSwallowing(BaseExceptionHandlerOperator):
    def mutate_ExceptHandler(self, node):
        if len(node.body) == 1 and isinstance(node.body[0], ast.Pass):
            raise MutationResign()
        return self._replace_exception_body(node, [ast.Pass(lineno=node.body[0].lineno)])

    @classmethod
    def name(cls):
        return 'EXS'
